      SUBROUTINE SFFLUX_B(trac, tracb, fland, flandb, dshj, dshjb, il1, 
     +                    il2, ilg, lev, ilev, ntr, icomp, subname, t, 
     +                    tb, fintrow, volcrow, aso4row, aso4rowb, 
     +                    pso4row, pso4rowb, poso4row, poso4rowb, blcrow
     +                    , blcrowb, dmsorow, dmslrow, h2srow, gt, 
     +                    aso2row, pso2row, poso2row, isize, rhop0, 
     +                    rhop0b, zhlev, pxnew, pxnewb, rgd, aerosize, 
     +                    aerosizeb, surfwd, surfwdb, rsfrow, rsfrowb, 
     +                    pressg, pressgb, icam, roa, gc, iae1, ih2s, 
     +                    idms, iso2, iso4, irest, luc, i_ss, omcrow, 
     +                    omcrowb, sand2row, clay2row, fsnow, srel, nats
     +                    , nsoil, mode, mae, ns, z0, soilw, ss, surfdg
     +                    , sand6row, tbar, ano3row, ano3rowb, pno3row, 
     +                    pno3rowb, pono3row, pono3rowb, rrdrow, rrdrowb
     +)
      IMPLICIT NONE
      INTEGER lev
      INTEGER ilg
      INTEGER ilev
Cz1     8                SAND6ROW, TBAR,   RAINFALL)
C------------------------------------------------------------------------------
C     PURPOSE:
C     --------
C     CALCULATE SURFACE FLUXES FOR AEROSOLS
C
C     HISTORY:
C     --------
C
C     * DEC. 22/2000 S.L. GONG   SOIL DUST EMISSION SCHEME IS ADDED
C     *                          GLOBAL 1x 1?SOIL TEXTURE DATA WAS
C     *                          USED FROM GCM12.
C     * MAR. 13/99 - S.L. GONG   GLOBAL OM SURFACE EMISSION [1x 1]
C
C
C     * FEB. 17/98 - S.L. GONG   GLOBAL BLACK CARBON SURFACE EMISSION [1x 1]
C     *                          WAS ADDED.
C     * JAN. 20/98 - S.L. GONG   GLOBAL DMS OCEAN CONCENTRATION DATA IS ADDED
C     *                          THE FLUX IS CALCULATED BY MASS TRANSFER
C     *                          EQUATION
C     * DEC. 20/96 - S.L. GONG   VECTORIZED THE FLUX CALCULATION FOR SEA-SALT
C     *                          AEROSOLS
C     * NOV. 21/94 - S.L. GONG   AEROSOL SURFACE FLUX COMPUTATION
C     *                          FOR SEA-SALT
C     *
C
C------------------------------------------------------------------------------
C
      REAL t(ilg, lev), zhlev(ilg, ilev), gt(ilg), gc(ilg)
      REAL tb(ilg, lev)
      INTEGER luc
      INTEGER ntr
      REAL fland(ilg, luc), trac(ilg, lev, ntr), dshj(ilg, ilev)
      REAL flandb(ilg, luc), tracb(ilg, lev, ntr), dshjb(ilg, ilev)
      REAL aso4row(ilg), pso4row(ilg), blcrow(ilg, 3, 2), rrdrow(ilg, 3
     +     , 2), omcrow(ilg, 3, 2)
      REAL aso4rowb(ilg), pso4rowb(ilg), blcrowb(ilg, 3, 2), rrdrowb(ilg
     +     , 3, 2), omcrowb(ilg, 3, 2)
      REAL aso2row(ilg), pso2row(ilg), volcrow(ilg, 2)
      REAL poso4row(ilg), poso2row(ilg)
      REAL poso4rowb(ilg)
      REAL ano3row(ilg), pno3row(ilg), pono3row(ilg)
      REAL ano3rowb(ilg), pno3rowb(ilg), pono3rowb(ilg)
      INTEGER isize
      REAL rgd(ilg, ilev, ntr), roa(ilg, ilev), fintrow(ilg, isize, 3)
      REAL dmsorow(ilg), dmslrow(ilg), h2srow(ilg)
      INTEGER icomp
      REAL aerosize(2, isize), surfwd(ilg), rhop0(icomp)
      REAL aerosizeb(2, isize), surfwdb(ilg), rhop0b(icomp)
      REAL rsfrow(ilg, ntr), pressg(ilg), pxnew(ilg, ilev, ntr)
      REAL rsfrowb(ilg, ntr), pressgb(ilg), pxnewb(ilg, ilev, ntr)
      INTEGER nsoil
      INTEGER nats
      REAL sand2row(ilg, nats), clay2row(ilg, 2), srel(ilg, nsoil, nats)
      INTEGER ns
      REAL z0(luc, ns), ss(ilg, nsoil), surfdg(ilg), soilw(ilg)
      REAL fsnow(ilg), sand6row(ilg, 6), tbar(ilg)
      CHARACTER*8 subname(icomp)
      REAL rainfall(ilg)
      INTEGER n
      INTEGER i
      INTEGER nn
      INTEGER branch
      INTEGER il1
      INTEGER il2
      INTEGER icam
      INTEGER irest
      INTEGER i_ss
      INTEGER idms
      INTEGER iae1
      INTEGER mae
      INTEGER iso2
      INTEGER iso4
      INTEGER ih2s
      INTEGER mode
      INTEGER ii3
      INTEGER ii2
      REAL fintrowb(ilg, isize, 
     +     3)
      INTEGER ii1
C
C
C     * ZERO SURFACE FIELDS OF CAM COMPONENTS
C     
C      print*,'il1=',il1,'il2=',il2
      DO n=iae1,icam
        DO i=il1,il2
          rsfrow(i, n) = 0.0
        ENDDO
      ENDDO
C
C     * SURFACE FLUX CALCULATION
C
      DO nn=1,icomp
C
C      * SULPHATE AEROSOLS
C-------------------------
        IF (subname(nn) .EQ. 'SULPHATE') THEN
          CALL PUSHreal8ARRAY(pxnew, ilg*ilev*ntr)
          CALL SFSF(trac, dshj, ilg, lev, ilev, mae, ntr, nn, isize, 
     +              aerosize, volcrow, aso4row, pso4row, poso4row, 
     +              aso2row, pso2row, poso2row, pressg, roa, dmsorow, 
     +              dmslrow, h2srow, pxnew, rsfrow, rgd, surfwd, zhlev, 
     +              fland, il1, il2, iae1, gt, ih2s, idms, iso2, luc)
          CALL PUSHCONTROL1B(0)
        ELSE
          CALL PUSHCONTROL1B(1)
        END IF
C
        IF (subname(nn) .EQ. 'NITRATES') THEN
          CALL PUSHreal8ARRAY(pxnew, ilg*ilev*ntr)
C
          CALL SFNT(trac, dshj, ilg, lev, ilev, mae, ntr, nn, isize, 
     +              aerosize, ano3row, pno3row, pono3row, pressg, roa, 
     +              pxnew, rsfrow, rgd, zhlev, il1, il2, iae1)
          CALL PUSHCONTROL1B(0)
        ELSE
          CALL PUSHCONTROL1B(1)
        END IF
C      print*,'1111111',subname(NN)
C
C      * SEA-SALT AEROSOLS
C-------------------------
        IF (subname(nn) .EQ. 'SEA-SALT') THEN
          CALL PUSHreal8ARRAY(fintrow, ilg*isize*3)
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 5))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 4))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 2))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 1))
          ENDDO
          CALL SFSS(trac, dshj, ilg, lev, ilev, pxnew(1, 1, 1), pxnew(1
     +              , 1, 2), pxnew(1, 1, 3), pxnew(1, 1, 4), pxnew(1, 1
     +              , 5), i_ss, t, ntr, nn, icomp, isize, luc, aerosize
     +              , surfwd, rhop0, rsfrow, pressg, gc, fland, fintrow
     +              , il1, il2, iae1, irest)
          CALL PUSHCONTROL1B(0)
        ELSE
          CALL PUSHCONTROL1B(1)
        END IF
C
C      * BLACK-CARBON AEROSOLS
C-------------------------
        IF (subname(nn) .EQ. 'BLCARBON') THEN
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 1))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 2))
          ENDDO
          CALL SFBC(trac, dshj, ilg, lev, ilev, pxnew(1, 1, 2), t, ntr, 
     +              nn, icomp, isize, zhlev, aerosize, rhop0, rsfrow, 
     +              pressg, pxnew(1, 1, 3), mae, blcrow, pxnew(1, 1, 1)
     +              , il1, il2, iae1)
          CALL PUSHCONTROL1B(0)
        ELSE
          CALL PUSHCONTROL1B(1)
        END IF
C
C      * ORGANIC-CARBON AEROSOLS
C-------------------------
        IF (subname(nn) .EQ. 'OMCARBON') THEN
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 1))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 2))
          ENDDO
          CALL SFOC(trac, dshj, ilg, lev, ilev, pxnew(1, 1, 2), t, ntr, 
     +              nn, icomp, isize, zhlev, aerosize, rsfrow, pressg, 
     +              pxnew(1, 1, 3), mae, omcrow, pxnew(1, 1, 1), il1, 
     +              il2, iae1)
          CALL PUSHCONTROL1B(0)
        ELSE
          CALL PUSHCONTROL1B(1)
        END IF
C
C
C     * SOLID DUSTS AEROSOLS
C--------------------------
C    
        IF (subname(nn) .EQ. 'SOILDUST') THEN
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 1))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=1,ilg
            CALL PUSHreal8(pxnew(ii1, 1, 2))
          ENDDO
C           print*,'test00'
C               CALL SFSD (TRAC,  DSHJ,   ILG,   LEV,  ILEV,
C     1                  SURFDG,   NTR,    NN, ICOMP, ISIZE,
C     2                AEROSIZE, RHOP0,RSFROW,PRESSG, FLAND,
C     3                  SURFWD,   ROA,   IL1,   IL2,  IAE1,
C     4         PXNEW(1,1,1),PXNEW(1,1,2),  SREL,PXNEW(1,1,3),
C     5     SAND2ROW,CLAY2ROW,SOILW,PXNEW(1,1,4),PXNEW(1,1,5),
C     6         PXNEW(1,1,7),PXNEW(1,1,8),
C     5                  NS,  Z0,   LUC, PXNEW(1,1,6),  NATS,
C     7         NSOIL, MODE,PXNEW(1,1,9),SS, PXNEW(1,1,10),
C     8     FSNOW,PXNEW(1,1,11),PXNEW(1,1,12),PXNEW(1,1,13),
C     9     SAND6ROW, TBAR)
C    , RAINFALL)
C          print*,'test01'
C
          CALL SFRD(trac, dshj, ilg, lev, ilev, pxnew(1, 1, 2), t, ntr, 
     +              nn, icomp, isize, zhlev, aerosize, rhop0, rsfrow, 
     +              pressg, pxnew(1, 1, 3), mae, rrdrow, pxnew(1, 1, 1)
     +              , il1, il2, iae1)
          CALL PUSHCONTROL1B(1)
        ELSE
          CALL PUSHCONTROL1B(0)
        END IF
      ENDDO
      DO ii1=1,3
        DO ii2=1,isize
          DO ii3=1,ilg
            fintrowb(ii3, ii2, ii1) = 0.0
          ENDDO
        ENDDO
      ENDDO
      DO nn=icomp,1,-1
        CALL POPCONTROL1B(branch)
        IF (branch .NE. 0) THEN
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 2))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 1))
          ENDDO
CCCCCzhaisx adds at 20140922 to initial0 rrdrowb
          rrdrowb = 0.0  
          CALL SFRD_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, pxnew(1
     +                , 1, 2), pxnewb(1, 1, 2), t, ntr, nn, icomp, isize
     +                , zhlev, aerosize, aerosizeb, rhop0, rsfrow, 
     +                rsfrowb, pressg, pressgb, pxnew(1, 1, 3), pxnewb(1
     +                , 1, 3), mae, rrdrow, rrdrowb, pxnew(1, 1, 1), 
     +                pxnewb(1, 1, 1), il1, il2, iae1)
        END IF
        CALL POPCONTROL1B(branch)
        IF (branch .EQ. 0) THEN
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 2))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 1))
          ENDDO
CCCCCzhaisx adds at 20140922 to initial0 adj var
          omcrowb = 0.0
          CALL SFOC_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, pxnew(1
     +                , 1, 2), pxnewb(1, 1, 2), t, ntr, nn, icomp, isize
     +                , zhlev, aerosize, aerosizeb, rsfrow, rsfrowb, 
     +                pressg, pressgb, pxnew(1, 1, 3), pxnewb(1, 1, 3), 
     +                mae, omcrow, omcrowb, pxnew(1, 1, 1), pxnewb(1, 1
     +                , 1), il1, il2, iae1)
        END IF
        CALL POPCONTROL1B(branch)
        IF (branch .EQ. 0) THEN
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 2))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 1))
          ENDDO
c          print*,'before call sfbc_b sum(blcrowb)=',sum(blcrowb)
CCCCCzhaisx adds at 20140922 to initial0 adj var
          blcrowb = 0.0
          CALL SFBC_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, pxnew(1
     +                , 1, 2), pxnewb(1, 1, 2), t, ntr, nn, icomp, isize
     +                , zhlev, aerosize, aerosizeb, rhop0, rsfrow, 
     +                rsfrowb, pressg, pressgb, pxnew(1, 1, 3), pxnewb(1
     +                , 1, 3), mae, blcrow, blcrowb, pxnew(1, 1, 1), 
     +                pxnewb(1, 1, 1), il1, il2, iae1)
c          print*,'after call sfbc_b sum(blcrowb)=',sum(blcrowb)
        END IF
        CALL POPCONTROL1B(branch)
        IF (branch .EQ. 0) THEN
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 1))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 2))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 3))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 4))
          ENDDO
          DO ii1=ilg,1,-1
            CALL POPreal8(pxnew(ii1, 1, 5))
          ENDDO
          CALL POPreal8ARRAY(fintrow, ilg*isize*3)

          CALL SFSS_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, pxnew(1
     +                , 1, 1), pxnewb(1, 1, 1), pxnew(1, 1, 2), pxnewb(1
     +                , 1, 2), pxnew(1, 1, 3), pxnewb(1, 1, 3), pxnew(1
     +                , 1, 4), pxnewb(1, 1, 4), pxnew(1, 1, 5), pxnewb(1
     +                , 1, 5), i_ss, t, tb, ntr, nn, icomp, isize, luc, 
     +                aerosize, aerosizeb, surfwd, surfwdb, rhop0, 
     +                rhop0b, rsfrow, rsfrowb, pressg, pressgb, gc, 
     +                fland, flandb, fintrow, fintrowb, il1, il2, iae1, 
     +                irest)
        END IF
        CALL POPCONTROL1B(branch)
        IF (branch .EQ. 0) THEN
          CALL POPreal8ARRAY(pxnew, ilg*ilev*ntr)
CCCCCzhaisx adds at 20140922 to initial0 adj var
          pono3rowb = 0.0
          CALL SFNT_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, mae, ntr
     +                , nn, isize, aerosize, ano3row, ano3rowb, pno3row
     +                , pno3rowb, pono3row, pono3rowb, pressg, pressgb, 
     +                roa, pxnew, pxnewb, rsfrow, rsfrowb, rgd, zhlev, 
     +                il1, il2, iae1)
        END IF
        CALL POPCONTROL1B(branch)
        IF (branch .EQ. 0) THEN
          CALL POPreal8ARRAY(pxnew, ilg*ilev*ntr)
CCCCCzhaisx adds at 20140922 to initial0 adj var
          aso4rowb = 0.0
          pso4rowb = 0.0
          poso4rowb = 0.0
          
          CALL SFSF_B(trac, tracb, dshj, dshjb, ilg, lev, ilev, mae, ntr
     +                , nn, isize, aerosize, aerosizeb, volcrow, aso4row
     +                , aso4rowb, pso4row, pso4rowb, poso4row, poso4rowb
     +                , aso2row, pso2row, poso2row, pressg, pressgb, roa
     +                , dmsorow, dmslrow, h2srow, pxnew, pxnewb, rsfrow
     +                , rsfrowb, rgd, surfwd, zhlev, fland, il1, il2, 
     +                iae1, gt, ih2s, idms, iso2, luc)
        END IF
      ENDDO
      DO n=icam,iae1,-1
        DO i=il2,il1,-1
          rsfrowb(i, n) = 0.0
        ENDDO
      ENDDO
      END
