      SUBROUTINE CHEM_TRVDIFF2_B(frtr, frtrb, tr_loc, kt, s, dt, gni, 
     +                           gnk, gntrnb, trnch)
      IMPLICIT NONE
      REAL cpd, cpv, rgasd, rgasv, trpl, tcdk, rauw, eps1, eps2
      REAL delta, cappa, tgl, consol, grav, rayt, stefan, pi
      REAL omega
      REAL knams, stlo, karman, ric, chlc, chlf
      REAL t1s, t2s, aw, bw, ai, bi, slp
      LOGICAL init
      PARAMETER (init=.true.)
      PARAMETER (cpd=.100546e+4)
      PARAMETER (cpv=.186946e+4)
      PARAMETER (rgasd=.28705e+3)
      PARAMETER (rgasv=.46151e+3)
      PARAMETER (trpl=.27316e+3)
      PARAMETER (tcdk=.27315e+3)
      PARAMETER (rauw=.1e+4)
      PARAMETER (eps1=.62194800221014)
      PARAMETER (eps2=.3780199778986)
      PARAMETER (delta=.6077686814144)
      PARAMETER (cappa=.28549121795)
      PARAMETER (tgl=.27316e+3)
      PARAMETER (consol=.1367e+4)
      PARAMETER (grav=.980616e+1)
      PARAMETER (rayt=.637122e+7)
      PARAMETER (stefan=.566948e-7)
      PARAMETER (pi=.314159265359e+1)
      PARAMETER (knams=.514791)
      PARAMETER (stlo=.6628486583943e-3)
      PARAMETER (karman=.35)
      PARAMETER (ric=.2)
      PARAMETER (chlc=.2501e+7)
      PARAMETER (chlf=.334e+6)
      PARAMETER (t1s=.27316e+3)
      PARAMETER (t2s=.25816e+3)
      PARAMETER (aw=.3135012829948e+4)
      PARAMETER (bw=.2367075766316e+1)
      PARAMETER (ai=.2864887713087e+4)
      PARAMETER (bi=.166093131502)
      PARAMETER (slp=.6666666666667e-1)
C constant used to calculate L/Cp in fcn
C          HTVOCP
C
C
      INTEGER gni, gnk, gntrnb, trnch, status
      REAL kt(gni, gnk), s(gni, gnk)
      REAL frtr(gni, gnk, gntrnb)
      REAL frtrb(gni, gnk, gntrnb)
      INTEGER tr_loc(gntrnb)
      REAL dt
      REAL rsg, gam0
C
      REAL seloc(gni, gnk)
      REAL tu(gni, gnk)
      REAL wka(gni, gnk)
      REAL wkb(gni, gnk), wkc(gni, gnk), wkd(gni, gnk), ktx(gni, gnk)
      INTEGER i, j, k, itr
      INTEGER arg1
      REAL tmp
      INTEGER branch
      REAL wkbb(gni, gnk
     +     )
      REAL wkab(gni, gnk
     +     )
      REAL wkdb(gni, gnk
     +     )
      REAL wkcb(gni, gnk
     +     )
      INTEGER ii2
      INTEGER ii1
      REAL tub(gni, gnk)
C----------------------------------------------------------------------------
Czhjh: .true. to gain S on half levels .
C
      CALL DIFUVD9(seloc, .true., s, gni, gnk, gnk)
C
C
      DO k=1,gnk-1
        DO i=1,gni
C          if(k.gt.gnk-2.and.KT(i,k).lt.0.1)          KT(i,k)=0.1            
          IF (k .EQ. gnk - 1 .AND. kt(i, gnk) .GT. kt(i, k)) THEN
            tmp = kt(i, gnk)
            kt(i, k) = tmp
          END IF
C          if(kt(i,k).lt.0.1.and.k.gt.19) write(*,*) 'KT-small',i,k, KT(i,k)
C
          ktx(i, k) = kt(i, k)
        ENDDO
      ENDDO
C
      DO itr=1,gntrnb
        arg1 = gni*gnk
        CALL PUTZERO(tu, arg1)
C
        IF (tr_loc(itr) .EQ. 0) THEN
          CALL PUSHINTEGER4(gni)
          CALL PUSHreal8ARRAY(wkd, gni*gnk)
          CALL PUSHreal8ARRAY(wkc, gni*gnk)
          CALL PUSHreal8ARRAY(wkb, gni*gnk)
          CALL PUSHreal8ARRAY(wka, gni*gnk)
          CALL PUSHreal8ARRAY(tu, gni*gnk)
          DO ii1=1,gni
            CALL PUSHreal8(frtr(ii1, 1, itr))
          ENDDO
          CALL DIFVCHEM(frtr(1, 1, itr), tu, ktx, s, seloc, wka, wkb, 
     +                  wkc, wkd, dt, gni, gnk)
          CALL PUSHCONTROL1B(1)
        ELSE
          CALL PUSHCONTROL1B(0)
        END IF
      ENDDO
      DO ii1=1,gnk
        DO ii2=1,gni
          tub(ii2, ii1) = 0.0
        ENDDO
      ENDDO
      DO ii1=1,gnk
        DO ii2=1,gni
          wkab(ii2, ii1) = 0.0
        ENDDO
      ENDDO
      DO ii1=1,gnk
        DO ii2=1,gni
          wkbb(ii2, ii1) = 0.0
        ENDDO
      ENDDO
      DO ii1=1,gnk
        DO ii2=1,gni
          wkcb(ii2, ii1) = 0.0
        ENDDO
      ENDDO
      DO ii1=1,gnk
        DO ii2=1,gni
          wkdb(ii2, ii1) = 0.0
        ENDDO
      ENDDO
      DO itr=gntrnb,1,-1
        CALL POPCONTROL1B(branch)
        IF (branch .NE. 0) THEN
          DO ii1=gni,1,-1
            CALL POPreal8(frtr(ii1, 1, itr))
          ENDDO
          CALL POPreal8ARRAY(tu, gni*gnk)
          CALL POPreal8ARRAY(wka, gni*gnk)
          CALL POPreal8ARRAY(wkb, gni*gnk)
          CALL POPreal8ARRAY(wkc, gni*gnk)
          CALL POPreal8ARRAY(wkd, gni*gnk)
          CALL POPINTEGER4(gni)
          CALL DIFVCHEM_B(frtr(1, 1, itr), frtrb(1, 1, itr), tu, tub, 
     +                    ktx, s, seloc, wka, wkab, wkb, wkbb, wkc, wkcb
     +                    , wkd, wkdb, dt, gni, gnk)
        END IF
        arg1 = gni*gnk
        CALL PUTZERO_B(tu, tub, arg1)
      ENDDO
      END
