   program aerosol_driver 
!------------------------------------------------------------------
   IMPLICIT NONE
!------------------------------------------------------------------

   INTEGER       ids,ide, jds,jde, kds,kde, &
                 ims,ime, jms,jme, kms,kme, &
                 its,ite, jts,jte, kts,kte
   INTEGER       number_tracer_temp,number_tracer
   
   INTEGER       num_soil_texture_temp,num_soil_texture

   INTEGER       num_clay_temp,num_clay
  
   INTEGER       num_desert_temp,num_desert 

   INTEGER       num_landuse_temp,num_landuse

   INTEGER       num_emission_temp,num_emis,num_emission

   INTEGER       JULDAY_temp,itimestep,JULDAY  


!   PARAMETER(ids =1,ide =230, jds =1,jde =100, kds =1,kde =32,&
!             ims =55,ime =91, jms =83,jme =97, kms =0,kme =32,&
!             its =59,ite =87, jts =87,jte =93, kts =1,kte =31)
    PARAMETER(ids =1,ide =230, jds =1,jde =100, kds =1,kde =32,&
              ims =140,ime =176, jms =41,jme =54, kms =0,kme =32,&
              its =144,ite =172, jts =45,jte =50, kts =1,kte =31)

   PARAMETER(number_tracer_temp =150,num_soil_texture_temp =12,&
             num_clay_temp =2,num_desert_temp =6,&
             num_landuse_temp =15,num_emission_temp =96,&
             JULDAY_temp =183)                                          !jinmin 20110702

   REAL        DEGRAD,             &
                                       XTIME,DECLIN,SOLCON
!
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme )                  &
          ::                                   P3D,P3DB, &
   			        	     		   P8W3D, &
                                                          P8W3DB, &
					        	    pi3D, &
					        	     T3D, &
                                                            T3DB, &
					        	    QV3D, &
                                                           QV3DB, &
					        	    QC3D, &
               	       fktm,dz8w,U3D,V3D,W3D,RHO3D,CLDFRA3D


   REAL,DIMENSION(ims:ime,kms:kme,jms:jme,number_tracer_temp)            &
          ::                              tracerb,      tracer  

   real,dimension(ims:ime,jms,jme):: tracer_test


!xuemin
   REAL,DIMENSION(ims:ime,kms:kme,jms:jme)                       &
          ::                                    umf3d, &
                                                           uer3d, &
                                                           udr3d, &
                                                           dmf3d, &
                                                           der3d
!CSLG
   REAL,DIMENSION(ims:ime,kms:kme,jms:jme)                       &
          ::                                 cld_fn3d, &
                                                            ww3d, &
                                                mc3db,      mc3d, &
                                                dp3db,      dp3d, &
                                                zfg3db,     zfg3d
!CSLG
   REAL, DIMENSION( ims:ime, jms:jme )                           &
          ::     dsubcld2db,           dsubcld2d, &
                            esp02d,    mb2d,mb2db

   INTEGER, DIMENSION( ims:ime, jms:jme )                           &
           ::                               ideep2d , &
                                                            jt2d, &
                                                          maxg2d, &
                                                            jd2d
   INTEGER, DIMENSION(jms:jme )   ::     lengath1d

! zch 20100224
   REAL, DIMENSION(ims:ime,kms:kme,jms:jme) ::   PSO43d
   REAL, DIMENSION(ims:ime,kms:kme,jms:jme) ::   PSOA3d

   REAL,DIMENSION(ims:ime,jms:jme,num_soil_texture_temp)              &
          ::                                     sand2
  
   REAL,DIMENSION(ims:ime,jms:jme,num_clay_temp)                      &
          ::                                     clay2

   REAL,DIMENSION(ims:ime,jms:jme,num_desert_temp)                    &
          ::                                     sand6

   REAL,DIMENSION(ims:ime,jms:jme,num_landuse_temp)                   &
          ::                      flandb,               fland

   REAL,DIMENSION(ims:ime,jms:jme,num_emission_temp)                   &
          ::                       emissionb,              emission 

   REAL,DIMENSION(ims:ime,jms:jme,number_tracer_temp)                   &
          ::                                   sfdust,  &
                                                           gdrem1,  &
                                                           gdrem2,  &
                                                           gdrem3
   REAL,DIMENSION(ims:ime,jms:jme,number_tracer_temp)                   &
       ::                                   sfdustb,  &
                                                        gdrem1b,  &
                                                        gdrem2b,  &
                                                       gdrem3b

   REAL, DIMENSION( ims:ime, kms:kme, jms:jme )                    &
          ::                                TU 



   REAL,DIMENSION(ite-its+1,num_soil_texture_temp) ::             sand2_2d      

   REAL,DIMENSION(ite-its+1,num_clay_temp)         ::             clay2_2d       

   REAL,DIMENSION(ite-its+1,num_desert_temp)       ::             sand6_2d

   REAL,DIMENSION(ite-its+1,num_landuse_temp)      ::             fland_2d 
   
   REAL,DIMENSION(ite-its+1,3,2)              ::             BLCROW
   
   REAL,DIMENSION(ite-its+1,3,2)              ::             OMCROW
!zch 20100224
   REAL,DIMENSION(ite-its+1,3,2)              ::             RRDROW
   
   REAL,DIMENSION(ite-its+1)                  ::             ASO2ROW 
   REAL,DIMENSION(ite-its+1)                  ::             PSO2ROW 
   REAL,DIMENSION(ite-its+1)                  ::             POSO2ROW 
   REAL,DIMENSION(ite-its+1)                  ::             ASO4ROW 
   REAL,DIMENSION(ite-its+1)                  ::             PSO4ROW 
   REAL,DIMENSION(ite-its+1)                  ::             POSO4ROW 
   REAL,DIMENSION(ite-its+1)                  ::             DMSOROW 
   REAL,DIMENSION(ite-its+1)                  ::             DMSLROW 
   REAL,DIMENSION(ite-its+1)                  ::             H2SROW 
   REAL,DIMENSION(ite-its+1,2)                ::             VOLCROW 
   REAL,DIMENSION(ite-its+1)                  ::             ANO3ROW
   REAL,DIMENSION(ite-its+1)                  ::             PNO3ROW
   REAL,DIMENSION(ite-its+1)                  ::             PONO3ROW

   REAL,DIMENSION(ite-its+1,number_tracer_temp)    ::             rsfdust, &
                                                             gdrem1_2d, &
                                                             gdrem2_2d, &
                                                             gdrem3_2d



!
   REAL, DIMENSION( ims:ime, jms:jme )                           &
          ::                                  XLAT,xlatb, &
                                                      xlongb, XLONG, &
                         u10,v10,TMN,SMSTOT,SNOW2D,ICE2D,ALB, &
                            SNOW2DB,ICE2DB,u10B,v10B

! xuemin
   REAL, DIMENSION( ims:ime,  kms:kme,jms:jme )                &
          ::                                      prate1,&
                                                             prate2

   REAL, DIMENSION( ims:ime, kms:kme, jms:jme )              &
          ::                                wrscav,&
                                                       zfprec,&
                                                       wpevpa


   REAL, DIMENSION( ims:ime, jms:jme )                           &
          ::                                raincv,rainncv 

!
   REAL, DIMENSION( ims:ime, jms:jme )                           &
          ::                                      GSW,gswb
!
   REAL                                   dt,GMT
!
 
! LOCAL VARS
 
   REAL, DIMENSION( ite-its+1 ) ::                                  &
                                                              ts, &
                                                            cosz, &
          snow,ice,surfwd,ftsoil,ffdss,lat_deg,long_deg,fhs,psfc, &
                                                          albs
!xuemin
 REAL, DIMENSION( ite-its+1,kts:kte-1,2 ) ::              prate_2d
 REAL, DIMENSION( ite-its+1,kts:kte-1 )::              &
                                                       wrscav_2d,&
                                                       zfprec_2d,&
                                                       wpevpa_2d

!SLG
   REAL, DIMENSION( ite-its+1 ) ::                                &
                                                         dsubcld, &
                                       esp0,mb
   INTEGER, DIMENSION( ite-its+1 ) ::                           &
                                                         ideep, &
                                                            jt, &
                                                          maxg, &
                                                            jd
    INTEGER lengath

   REAL, DIMENSION( ite-its+1,2 ) ::                        qr
!   REAL, DIMENSION( ite-its+1,kts:kte-1 ) ::                mu,eu 
!
   REAL, DIMENSION( ite-its+1, kts:kte ) ::                     O3
!
   REAL, DIMENSION( ite-its+1, kts:kte+1 ) ::                    &
						           P8W2D
  
   REAL, DIMENSION( ite-its+1, kts:kte ) ::                       &
        						    SH2D, &
        						    QC2D, &
						             P2D, &
        						     T2D, &
        						     U2D, &
        						     V2D, &
        						     W2D, &
                                                           RHO2D, &
                         fktm2d,sig,hght,fmodv,fdz,frclds,frcldc, &
                                                          fcld2D

   REAL, DIMENSION(ite-its+1,kts:kte-1) :: umf,uer,udr,dmf,der   

!CSLG
   REAL, DIMENSION(ite-its+1,kts:kte-1) :: cld_fn,ww,mc,dp,zfg
   REAL, DIMENSION( ite-its+1, kts:kte,number_tracer_temp) :: aero_tr
   REAL, DIMENSION( ite-its+1, kts:kte)               :: TU_2D  
!zch 20100224
   REAL, DIMENSION( ite-its+1, kts:kte) ::  pso4,psoa

!
   INTEGER :: i,j,k,nk,l,n,ii,testid
   REAL    :: xt24,tloctm,hrang,xxlat
!zhaisx
   integer n_moist,P_QV,P_QC
   PARAMETER(n_moist=4,P_QV=2,P_QC=3)
   real,dimension(ims:ime,kms:kme,jms:jme)::   t_phy,p_phy,   &
                                            p8w,pi_phy,       &
                                            cldfra,u_phy,     & 
                                            v_phy,w,rho_phy
   REAL,DIMENSION(ims:ime,jms:jme,n_moist) ::    albedo
   REAL,DIMENSION(ims:ime,kms:kme,jms:jme,n_moist) ::  moist   

   REAL INNER
   EXTERNAL Initial

!zhaisx20140319
character*2 type(7)
character*1,cnum
DATA type/'BC','OC','SD','SS','SF','NT','AM'/
integer itype,naero,ngas,isize,inum
parameter(naero=6,ngas=5,isize=12)

!  print*,'----before call aeroexe1-------------kts', kte
!    print *,ids,ide, jds,jde, kds,kde,                    &
!                    ims,ime, jms,jme, kms,kme,                    &
!                    its,ite, jts,jte, kts,kte  

   lengath1d=0
   ideep2d=0
   jt2d=0
   maxg2d=0
   jd2d=0
!   open(111,file='./../../Adj_camaerosol_final/camaerosol.input')
   open(111,file='./../../grapes_cuace_OK/camaerosol_input/camaerosol.input')
!   read(111,*)itimestep,dt,GSW,XLAT,XLONG,ALB,T3D,QV3D,QC3D, &
!                 P3D,P8W3D,dz8w,pi3D,CLDFRA3D,U3D,V3D,W3D,RHO3D, &
!                 GMT,XTIME,DECLIN,SOLCON,SNOW2D,ICE2D,prate1,prate2,raincv,rainncv, &
!                 TMN,u10,v10,SMSTOT,fktm,DEGRAD,tracer, sfdust,sand2, clay2, sand6, fland,emission, &
!                 gdrem1,gdrem2,gdrem3,TU,umf3d,uer3d,udr3d,dmf3d,der3d,wrscav,zfprec,wpevpa, &
!                 cld_fn3d,ww3d, mc3d,dp3d, mb2d,esp02d,zfg3d, dsubcld2d,PSO43d, PSOa3d


   read(111,*)itimestep,dt, &
                       GSW,XLAT,XLONG, &
                       ALBEDO,t_phy, &
                       moist(ims,kms,jms,P_QV),      &
                       moist(ims,kms,jms,P_QC),      &
                       p_phy,p8w,dz8w,pi_phy,CLDFRA,      &
                       u_phy,v_phy,w, rho_phy,     &
                       GMT,JULDAY,XTIME,DECLIN,SOLCON,   &
                       SNOW2D,ICE2D,                      &
                       prate1,prate2,raincv,rainncv,     &
                       TMN,u10,v10,SMSTOT,fktm,           &
                       DEGRAD,number_tracer,num_emission,tracer,sfdust,  &
  ! wh for dust  
                       num_soil_texture,num_clay,num_desert,num_landuse, &
                       sand2,clay2,sand6,fland,emission,                 &
                       gdrem1,gdrem2,gdrem3,TU,                      &
                       umf3d,uer3d,udr3d,dmf3d,der3d,                  &
                       wrscav,zfprec,wpevpa,                           &
  !CSLG
                     cld_fn3d,ww3d,mc3d,dp3d, mb2d,esp02d,zfg3d,    &   
                     dsubcld2d,ideep2d, jt2d, maxg2d, jd2d,         &
                                  lengath1d, & 
  !zch 20100224 for PSO4 and PSOA
                        pso43d,psoa3d
   close(111)
   
   open(30,file='XLAT.txt')
   write(30,101)XLAT
   100 FORMAT (F9.2)
   101 FORMAT(15(37F9.2/))
   close(30)

   open(31,file='XLONG.txt')
   write(31,101)XLONG
   close(31)

   open(40,file='emission_27.txt')
   write(40,101)emission(:,:,27)
   close(40)

!   open(32,file='tracer.txt')
!   write(*,*)sum(tracer)
!   close(32)


   print*,'read 1111 endding'
   print*,'itimestep',itimestep
!   open(11,file='camaerosol_tracer.txt')
!   write(11,*)tracer(55:65,1,83:90,2)
!   close(11)

!zhaisx writes 20140319
!first open a serial of data files
do itype=1,naero+1
open(10+itype,                                               &
        file='aero_'//type(itype)//'.grd',                   &   
        form='unformatted')
enddo

do itype=1,ngas+1
   write(cnum,'(i1)')itype
   write(*,*)cnum
   open(20+itype,                                            &
        file='gas_'//cnum//'.grd',                           &
        form='unformatted')
enddo
!open grd files ended

!6 different kinds of aerosols:'BC','OC','SD','SS','SF','NT'
!each has 12 bins
do itype=1,naero   !kinds of 6 aerosols 
  do inum=isize*itype-11,isize*itype    !12bins
    do k=kms,kme
     write(10+itype)((tracer(i,k,j,inum),i=ims,ime),j=jms,jme)
    enddo
  enddo
enddo

close(11)
close(12)
close(13)
close(14)
close(15)
close(16)


!AM,just has 1 bin
inum =74
do k=kms,kme
  write(11+naero)((tracer(i,k,j,73),i=ims,ime),j=jms,jme)
enddo
  
close(17)

do itype=1,ngas
do inum=isize*itype-11+74,isize*itype+74
do k=kms,kme
write(20+itype)((tracer(i,k,j,inum),i=ims,ime),j=jms,jme)
enddo
enddo
enddo

close(21)
close(22)
close(23)
close(24)
close(25)

do inum=134,140
do k=kms,kme
write(20+ngas+1)((tracer(i,k,j,inum),i=ims,ime),j=jms,jme)
enddo
enddo
close(26)

open(41,file='emission.grd',form='unformatted')
do num_emis=1,num_emission
   write(41)((emission(i,j,num_emis),i=ims,ime),j=jms,jme)
enddo
close(41)
!print*,'sum(emission(:,:,94))=',sum(emission(:,:,94))
   print*,'finish'


   END
